/* Network library  V1.0  25.2.1997	*/
/* copyright (c)1997 by Marek Zelem	*/ 
/* e-mail: marek@crazy.elf.stuba.sk	*/

#ifndef _NET_LIB_H
#define _NET_LIB_H

#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>

/*
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <arpa/inet.h>
*/

#define	iaddr_c2i(c)	(*(int *)(c))

typedef struct	{ int fd;
		  int p1,p2;
		  int(*func)(int,int*,int*);
		} comm_t;



/* Navratove hodnoty: 0-fatal error (not socket ... )
 *		      1-ok
 */

int net_verlib(char *ver);

struct sockaddr *net_fill_sockaddrin( struct sockaddr_in *sockaddr, unsigned int ip, int port );

/* Odstraninie domeny, ak je taka ista ako ma lokalny stroj */
char *net_minimalname(char *name);
char *net_maximalname( char *name );

/* Konverty */
int net_ip2asci(unsigned int ip, char *asci);
int net_name2ip(char *name, unsigned int *ip);
int net_ip2name(unsigned int ip, char *name);
int net_serv2port(char *serv,char *proto);
int net_text2port(char *text,char *proto);

/* fcntl ; vratia predchadzajucu hodnotu */
int net_s_noblock( int s );
int net_s_block( int s );
int net_s_set( int s, int fl );

/* Informacie (ak nie name,ip,port tak ==NULL ) */
int net_getpeer(int sock, char *name, unsigned int *ip, int *port );
int net_getme(int sock, char *name, unsigned int *ip, int *port );

/* Zistenie uzivatela */
int net_ident(unsigned int ip, int port, int myport, char *user);
int net_sockident(int sock, char *host, char *name );

/* Socket funkcie */
/* return socket if success or -1 if error */
int net_connect(unsigned int addr, int port);
int net_bind(int port);
int net_accept(int sock,char *name,unsigned int *ip,int *port);	/*name,ip,port -nepovinne*/
int net_udpbind( int port );
int net_udpsend(char *buf,int len,unsigned int ip,int port); /*vrati sock*/
int net_udprecv(int sock,char *buf,int maxlen,unsigned int *ip,int *port);
int net_udpconnect( unsigned int addr, int port );
int netnamed_connect(char *sockname);
int netnamed_bind(char *sockname);
int netnamed_accept(int sock,char *remotename);
int net_close(int sock);

/* General function */
int net_gnrl_connect( int sock, unsigned int ip, int port );
int net_gnrl_bind( int sock, int port );

/* Extra specialne funkcie by Marek Zelem */
int net_GATEconnect(unsigned int Gaddr, int Gport, unsigned int addr, int port, int extra);
void net_sigchildexit(int signum);	/* sig_exited_pid=waitpid ... */
void net_sigvoid(int signum);	/* void (for alarm) */
void net_siginc(int signum);	/* sig_signal[signum]++ */
void net_sigclose(int signum);	/* close(sig_close) */
void net_sigshutdown(int signum);	/* shutdown(sig_shutdown,2) */
void net_sigfork(int signum);	/* if( fork()>0 ) exit(0); */

/* Alokacia tty-ciek */
/* vrati fd pre pty alebo -1; in,out,io ak nie NULL, tak do nich zapise fd pre tty */
#define	net_ttyalloc(in,out,io)		net_ttyalloc_n((in),(out),(io),NULL)
int net_ttyalloc_n( int *in, int *out, int *io, char *name );
int net_fileopen( char *filename, int *in, int *out, int *io );
int net_ttyclean(int fd);
int net_ttyecho(int fd,int on);

/* Kolosalne funkcie */
pid_t net_tcpserver(int sock, void(*child)(int));


/* Pomocne funkcie */
int my_copy(int from, int to );
int net_printf(int sock,char *fmt, ...);
int net_gets(int sock,char *buf,int maxlen);
int net_getln(int sock,char *buf,int maxlen);
int net_cross(int s1,int s2);
int net_crossfunc(int s1,int s2,int(*f12)(char *,int) ,int(*f21)(char *,int) );
int net_tostdio(int s, int in, int out);
int net_comm(comm_t *tab,int n );
int net_mccp(int fd, int *p1, int *p2);	/*modul k net_comm  p1-fd na zapis*/

#endif _NET_LIB_H

