/*	io_extend
 * (c) by Marek Zelem
 */

#include <stdio.h>
#include <stdlib.h>
#include <mmm/io_lib.h>

/* io_extend use ptr2 of io */
int io_extend_init( io_t *io, int n )
{ int i;
	if( is_ioext_on(io) )	return(-1);
	if( (io->ptr2=malloc((n+1)*sizeof(ioextend_t)))==NULL )	return(-1);
	for(i=0;i<n;i++)
	{	ioext(io)[i].magic=0;
		ioext(io)[i].user=0;
		ioext(io)[i].num=0;
		ioext(io)[i].num1=0;
		ioext(io)[i].ptr=NULL;
	}
	ioextptr(io)=NULL;
	ioextn(io)=n;
	return(n);
}

int io_extend_resize( io_t *io, int n )
{ int i;
  void *p=io->ptr2;
	if( !is_ioext_on(io) )	return(-1);
	if( (io->ptr2=realloc(io->ptr2,(n+1)*sizeof(ioextend_t)))==NULL )
	{	io->ptr2=p;
		return(ioextn(io));
	}
	for(i=ioextn(io);i<n;i++)
	{	ioext(io)[i].magic=0;
		ioext(io)[i].user=0;
		ioext(io)[i].num=0;
		ioext(io)[i].num1=0;
		ioext(io)[i].ptr=NULL;
	}
	ioextn(io)=n;
	return(n);
}

int io_extend_del( io_t *io )
{
	if( io->ptr2 != NULL )
		free(io->ptr2);
	io->ptr2=NULL;
	return(0);
}

ioextend_t *io_extend_alloc( io_t *io, short magic )
{ int s,i;
	if( !is_ioext_on(io) )	return(NULL);
	if( magic<=0 )	return(NULL);
	i= s= magic % ioextn(io);
	while( ioext(io)[i].magic!=0 )
	{	i= (i+1) % ioextn(io);
		if( i == s )	return(NULL);
	}
	ioext(io)[i].magic= magic;
	return( &(ioext(io)[i]) );
}

ioextend_t *io_extend_find( io_t *io, short magic )
{ int s,i;
	if( !is_ioext_on(io) )	return(NULL);
	i= s= magic % ioextn(io);
	while( ioext(io)[i].magic!=magic )
	{	i= (i+1) % ioextn(io);
		if( i == s )	return(NULL);
	}
	return( &(ioext(io)[i]) );
}

int io_extend_release( io_t *io, short magic )
{ ioextend_t *e;
	if( (e=io_extend_find(io,magic))==NULL )	return(0);
	e->magic=0;
	return(1);
}

