/* iouf_all_to_all.c */
/* (c) by Marek Zelem    */

#include <mmm/io_lib.h>
#include <mmm/dynamic.h>

ddata_t	*all=NULL;

int _iolocal_find_me( io_t *me )
{ io_t **p;
  int i;
	p=(io_t**)dd_data(all);
	for(i=0;i<dd_n(all);i++)
		if( p[i]==me )	return(i);
	return(-1);
}

/* iouf_all_to_all
 * write to all who use this function
 */
int iouf_all_to_all( io_t *io, int what, void *arg )
{ io_t **p;
  int i;
	if( what==IO_RD )
	{
		p=(io_t**)dd_data(all);
		for(i=0;i<dd_n(all);i++)
		{	if( p[i]->outbuf==NULL )
			  if( (p[i]->outbuf=dfifo_create(1,128))==NULL )
				  continue;
			dfifo_copy(io->inbuf,p[i]->outbuf);
		}
		dfifo_clear(io->inbuf);
	}
	else if( what==IO_WR )
	{	dfifo_delete(io->outbuf);
		io->outbuf=NULL;
		if( io->rd<=0 ) return(-1);
	}
	else if( what==IO_CLOSED )	return(-1);
	else if( what==IO_INIT )
	{	if( all==NULL || _iolocal_find_me(io)<0 )
			all=dd_cappend(all,sizeof(io_t*),32,&io,1);
	}
	else if( what==IO_DEL )
	{	dd_delete(all,_iolocal_find_me(io),1);
		if( dd_n(all)<=0 )
		{	dd_free(all);	all=NULL;
		}
	}
	return(0);
}

