/* test fmemory
 */

#include <stdio.h>
#include <unistd.h>
#include <mmm/fmemory.h>
#include <mmm/menu.h>

types_t types[]={ STD_TYPES, END_TYPES };

void ret_int( int i )
{	printf("ret=%d\n",i);
}
void ret_long( long i )
{	printf("ret=%ld\n",i);
}
void ret_p( void *i )
{	printf("ret=%p\n",i);
}
void ret_id( long i )
{	printf("ret=0x%lx\n",i);
}

fmem_t *mem;
void f_start( void )
{	mem=fmem_create(16);
	if( mem==NULL )
		printf("ERROR\n");
}
void f_stop( void )
{	mem->destroy(mem);
}
void f_add_file( char *name )
{	ret_int(mem->add_file(mem,name));
}
void f_create_file( char *name, int id, long size )
{	ret_int(mem->create_file(mem,name,id,size));
}
void f_get( long addr )
{	ret_p(mem->get(mem,addr));
}
void f_get_size( long addr )
{	ret_long(mem->get_size(mem,addr));
}
void f_malloc( long size, int memid )
{	ret_id(mem->malloc(mem,size,memid));
}
void f_realloc( long addr, long size )
{	ret_id(mem->realloc(mem,addr,size));
}
void f_free( long addr )
{	ret_int(mem->free(mem,addr));
}

void print_mem( int memid )
{ struct fmem_file_s *f;
  struct fmem_blok_head_s *b;
  int id;
	id=mem->fileid_trans_table[memid];
	if( id==0xff )
	{	printf("bad memid\n"); return;	}
	f=&(mem->file[id]);
	printf("filename=\"%s\" size=%ld free=%ld\n",
			f->filename,f->size,f->mem->free);
	b=(struct fmem_blok_head_s *)
		(((char*)f->mem)+f->mem->first_offset);
	while( b->size>0 )
	{	printf("0x%x size=%ld prev=%ld cnt=%d (%lx,%d)\n",
			(memid<<24)+((char*)(b)-(char*)(f->mem))/16,
			b->size,b->prev,b->usecount,
			b->user_adr,b->user_id);
		b=(struct fmem_blok_head_s *)(((char*)b)+b->size);
	}
}

menu_t menu[]=	{
  {MENU_INIT,"mem>|Invalid command\n","?",NULL,f_start,
	  	""},
  {MENU_ITEM,"add","add mem file",NULL,f_add_file,"char *name"},
  {MENU_ITEM,"create","create mem file",NULL,f_create_file,"char *name,int id,long size"},
  {MENU_ITEM,"get","get pointer",NULL,f_get,"long addr"},
  {MENU_ITEM,"size","get size",NULL,f_get_size,"long addr"},
  {MENU_ITEM,"malloc","malloc",NULL,f_malloc,"long size, int memid"},
  {MENU_ITEM,"realloc","realloc",NULL,f_realloc,"long addr, long size"},
  {MENU_ITEM,"free","free",NULL,f_free,"long addr"},
  {MENU_ITEM,"print","print mem blocks",NULL,print_mem,"int memid"},
  {MENU_EXIT,"exit","Exit",NULL,NULL,NULL},
  {MENU_EXIT,"quit",NULL,NULL,NULL,NULL},
  {MENU_FINISH,NULL,NULL,NULL,f_stop,""},
  {MENU_END}
		};

int main( int argc, char *argv[] )
{ vars_t *vars;
  	if( (vars=var_init(types))!=NULL )
	{
		menu_text_command(menu_init(0,NULL,menu,vars));
	}
	return(0);
}

