/* test imemory
 */

#include <stdio.h>
#include <unistd.h>
#include <mmm/imemory.h>
#include <mmm/menu.h>

types_t types[]={ STD_TYPES, END_TYPES };

void ret_int( int i )
{	printf("ret=%d\n",i);
}
void ret_long( long i )
{	printf("ret=%ld\n",i);
}
void ret_p( void *i )
{	printf("ret=%p\n",i);
}
void ret_id( long i )
{	printf("ret=0x%lx\n",i);
}

imem_t *imem;
void i_start( void )
{	imem=imem_create(fmem_create(16));
	if( imem==NULL )
		printf("ERROR\n");
}
void i_stop( void )
{	imem->destroy(imem);
}
void f_add_file( char *name )
{	ret_int(imem->fmem->add_file(imem->fmem,name));
}
void i_create_index( int memid )
{	ret_int(imem->create_index(imem,memid));
}
void i_new( long size, int memid )
{	ret_id(imem->new(imem,size,memid));
}
void i_get( long id )
{	ret_p(imem->get(imem,id));
}
void i_size( long id )
{	ret_long(imem->size(imem,id));
}
void i_resize( long id, long size )
{	ret_int(imem->resize(imem,id,size));
}
void i_inc_use( long id )
{	ret_int(imem->inc_use(imem,id));
}
void i_dec_use( long id )
{	ret_int(imem->dec_use(imem,id));
}

menu_t menu[]=	{
  {MENU_INIT,"imem>|Invalid command\n","?",NULL,i_start,
	  	""},
  {MENU_ITEM,"add","add mem file",NULL,f_add_file,"char *name"},
  {MENU_ITEM,"create","create index",NULL,i_create_index,"int memid"},
  {MENU_ITEM,"new","new",NULL,i_new,"long size, int memid"},
  {MENU_ITEM,"get","get pointer",NULL,i_get,"long id"},
  {MENU_ITEM,"size","get size",NULL,i_size,"long id"},
  {MENU_ITEM,"resize","resize",NULL,i_resize,"long id, long size"},
  {MENU_ITEM,"inc","inc usecount",NULL,i_inc_use,"long id"},
  {MENU_ITEM,"dec","dec usecount",NULL,i_dec_use,"long id"},
  {MENU_EXIT,"exit","Exit",NULL,NULL,NULL},
  {MENU_EXIT,"quit",NULL,NULL,NULL,NULL},
  {MENU_FINISH,NULL,NULL,NULL,i_stop,""},
  {MENU_END}
		};

int main( int argc, char *argv[] )
{ vars_t *vars;
  	if( (vars=var_init(types))!=NULL )
	{
		menu_text_command(menu_init(0,NULL,menu,vars));
	}
	return(0);
}

