/* Security library			*/
/* copyright (c)1997 by Marek Zelem	*/
/* e-mail: marek@crazy.elf.stuba.sk	*/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <stdlib.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <mmm/secu_lib.h>

int secu_log(char *fname,char *fmt, ...)
{ time_t tim;
  FILE *f;
  va_list ap;
  char pom[128];
	va_start(ap,fmt);
	if( (f=fopen(fname,"a+"))==NULL )
	{	va_end(ap);
		return(0);
	}
	tim=time(NULL);
	strcpy(pom,ctime(&tim)); if(pom[0]) pom[strlen(pom)-1]=0;
	fprintf(f,"%s ",pom);
	vfprintf(f,fmt,ap);
	fclose(f);
	va_end(ap);
	return(1);
}


int secu_checkpass(char *question, char *answer)
{ char prom[128],salt[4];
  char *pass, *cr;
    sprintf(prom,"Enter answer for %s:",question);
    pass=getpass(prom);
    salt[0]=answer[0];
    salt[1]=answer[1];
    salt[2]=0;
    cr=crypt(pass,salt);
    if( !strcmp(answer,cr) )
    	return(1);
    return(0);
}

mpass_t *secu_mpopen(char *fname)
{ int i,j;
  int fd;
  int len;
  mpass_t *mp;
    if( (mp=(mpass_t *)malloc(sizeof(mpass_t)))==NULL )	return(NULL);
    if( (fd=open(fname,O_RDONLY))<0 )
    {	free(mp);
	return(NULL);
    }
    i=0; len=128;
    if( (mp->buf=malloc(len))==NULL )
    {	free(mp);
    	close(fd);
    	return(NULL);
    }
    while( (j=read(fd,(mp->buf)+i,len-i))==(len-i) )
    { i=j;
      if( (mp->buf=realloc(mp->buf,len+128))==NULL )
    	{	free(mp); close(fd); return(NULL);	}
      len+=128;
    }
    close(fd);
    mp->len=len;
    mp->n=i+j;
    j=0;
    mp->wn=0;
    mp->wlen=128;
    if( (mp->que=malloc(mp->wlen))==NULL )
    	{ free(mp->buf); free(mp); return(NULL); }
    if( (mp->ans=malloc(mp->wlen))==NULL )
    	{ free(mp->que); free(mp->buf); free(mp); return(NULL); }
    s=1;
    for(i=0;i<(mp->n);i++)
    { char c;
    	c=mp->buf[i];
    	if( s==1 && c!=' ' && c!='\t' && c!='\n' )
    	{	mp->que[j]=buf+i;
    		s=2;
	}
	else if( s==2 && (c==' ' || c=='\t' || c=='\n')
	{ mp->buf[i]=0; s=3; }
    	else if( s==3 && c!=' ' && c!='\t' && c!='\n' )
    	{	mp->ans[j]=buf+i;
		j++;
		if( j>=mp->wlen )
		{ mp->wlen+=64;
		if( (mp->que=realloc(mp->que,mp->wlen))==NULL )
			{ free(mp->buf); free(mp); return(NULL); }
		if( (mp->ans=realloc(mp->que,mp->wlen))==NULL )
			{ free(mp->que); free(mp->buf); free(mp); return(NULL); }
		}
    		s=0;
	}
	else if( s==0 && (c==' ' || c=='\t' || c=='\n')
	{ mp->buf[i]=0; s=1; }
    }
    mp->wn=j;
    return(mp);
}

int secu_mpclose(mpass_t *mp)
{
	free(mp->buf);
	free(mp->que);
	free(mp->ans);
	return(1);
}

int secu_mpwrite(mpass_t *mp,char *fname)
{ int i;
  FILE *f;
    if( (f=fopen(fname,"w"))==NULL )
	return(-1);
    for(i=0;i<(mp->wn);i++)
    {	if( mp->que[i]!=NULL )
    		fprintf(f,"%s %s\n",mp->que[i],mp->ans[i]);
    }
    fclose(f);
    return(i);
}

int secu_mpremove(mpass_t *mp,char *question)
{ int i;
    for(i=0;i<(mp->wn);i++)
    {	if( mp->que[i]!=NULL && !strcmp(mp->que[i],question) )
		{ mp->que[i]=NULL; mp->ans[i]=NULL; }
    }
    return(1);
}

int secu_mpadd(mpass_t *mp, char *question, char *answer)
{
    if( mp->len<=(mp->n+strlen(question)+strlen(answer)+2) )
    { mp->len+=strlen(question)+strlen(answer)+64;
      if( (mp->buf=realloc(mp->buf,mp->len))==NULL )
      	{ secu_mpclose(mp); return(0); }
    }
    mp->que[mp->wn]=mp->buf+mp->n;
    strcpy(mp->buf+mp->n,question);
    mp->n+=strlen(question)+1;
    mp->ans[mp->wn]=mp->buf+mp->n;
    strcpy(mp->buf+mp->n,answer);
    mp->n+=strlen(answer)+1;
    mp->wn++;
    if( mp->wn>=mp->wlen )
    {	mp->wlen+=16;
	if( (mp->que=realloc(mp->que,mp->wlen))==NULL )
		{ secu_mpclose(mp); return(0); }
	if( (mp->ans=realloc(mp->que,mp->wlen))==NULL )
		{ secu_mpclose(mp); return(0); }
    }
    return(1);
}

int secu_mpaddpass(mpass_t *mp, char *question)
{ char prom[128],salt[4];
  char *pass, *cr;
  char pom[128];
    sprintf(prom,"Enter new answer for %s:",question);
    pass=getpass(prom);
    strcpy(pom,pass);
    sprintf(prom,"Retype answer for %s:",question);
    pass=getpass(prom);
    if( strcmp(pass,pom) )
    { printf("Answer don't match!\n");
      return(0);
    }
    salt[0]='m';
    salt[1]='Z';
    salt[2]=0;
    cr=crypt(pass,salt);
    return(addquestion(mp,question,cr));
}
